// This program is a simple database of telephones.
// It has such operations as sorting, filtering and statistics.

program Telephones;
uses crt, tp, print, validation, sorting, advanceSearch;
//------------------------------------------------

//SAVES DATABASE
procedure save(s: stek);
var f: file of phone;
    x: phone;
begin

assign(f, 'database.dat');
rewrite(f);
if s = NIl then printNoData()
else
  begin
    repeat
       begin
          x.manfctr:= s^.manfctr;
          x.model:= s^.model;
          x.price:= s^.price;
          x.years:= s^.years;
          x.threeg:= s^.threeg;
          s:=s^.pointer;
          write(f, x);
       end;
    until s = NIL;
  end;
close(f);
printDbSaved();
end;
//--------------------------------------------------

//LOADS DATABASE
procedure load(var s: stek);
var f: file of phone;
    x: phone;
    p:stek;
    i: integer;
begin

assign(f, 'database.dat');
reset(f);
for i:= 1 to filesize(f) do
   begin
      read(f, x);
      new(p);
      p^.manfctr:= x.manfctr;
      p^.model:= x.model;
      p^.price:= x.price;
      p^.years:= x.years;
      p^.threeg:= x.threeg;
      p^.pointer:=s;
      s:=p;
   end;
close(f);
printDbLoaded();
end;
//------------------------------------------------

// WRITES STEK
procedure writeStek(s: stek);
var nr: integer;
 begin
    nr:= 1;
    printTableTop();
    repeat
    write(nr:3,'.');
    printTable(s);
    s:=s^.pointer;
    nr:= nr + 1;
    until s = NIL;
  end;
//------------------------------------------------

// CHECKS IF THERE IS A DATABESE AND THEN WRITES IT
procedure writef(s: stek);
begin
clrscr;

if s = nil then printNoData()
else
 begin
   writeStek(s);
   writeln;
   printEnterKey();
   readln;
   end;
end;
//-------------------------------------------------

// READS DATA
procedure insertData(var p: stek);
var str: string;
begin
writeln('Enter manufacturer');
readln(p^.manfctr);
writeln('Enter model');
readln(p^.model);
writeln('Enter price');
p^.price:= isPrice();
writeln('Enter year of release');
p^.years:= isYear();
writeln('Enter 3G capability (YES/NO)');
p^.threeG:= ynToBool(str);
end;
//-------------------------------------------------

// INSERTS DATA TO STACK
procedure insert(var s: stek);
var p: stek;
begin
clrscr;
new(p);
insertData(p);

p^.pointer:= s;
s:=p;
end;
//-------------------------------------------------

// CALCULATES AVARAGE PRICE OF TELEPHONES
procedure avarage(s: stek);
var sum, avrg: real;
    n: integer;
begin
clrscr;
sum:=0;
n:=0;

if s <> NIL then
  begin
    repeat
        sum:= sum + s^.price;
        n:= n + 1;
        s:= s^.pointer;
    until s = NIL;
    avrg:= sum / n;
    writeln('Avarage of prices is - ', avrg:8:2);
    printEnterKey();
  end
else printNoData();
readln;
printEnterKey();
end;
//-------------------------------------------------

// COUNTS TELEPHONES WITH 3G CAPABILITY
procedure num3gCap(s: stek);
var n: integer;
begin
clrscr;

n:=0;
if s = NIL then printNoData()
else
  begin
    repeat
       if s^.threeG = TRUE
           then n:= n + 1;
       s:= s^.pointer;
    until s = NIL;
    writeln('Number of telephones with 3G capability is - ',n);
    printEnterKey();
    readln;
    end;
end;
//-------------------------------------------------

// MENU OF STATISTIC OPERATIONS
procedure statistics(s: stek);
var selection, n: integer;
begin

repeat
clrscr;
Writeln('[1] Avarage of prices');
Writeln('[2] Number of telephones with 3G capability');
Writeln('[3] Go back to menu');

n:=3;
selection:= isSelection(n);

case selection of
1: avarage(s);
2: num3gCap(s);
end;
until selection = 3;

end;
//-------------------------------------------------

// FILTERS DATA BY MANUFACTURER
procedure filtByManfctr(s: stek);
var man: string;
    n: integer;
begin
clrscr;
Writeln('Enter manufacturer which phones you want to see');
readln(man);
clrscr;
n:=0;

if s = NIL then printNoData()
else
  begin
    repeat
    if man = s^.manfctr
     then
       begin
       if n = 0 then printTableTop();
       printTable(s);
       n:= 1;
       end;
  s:= s^.pointer;
  until s = NIL;
end;

if n = 0 then writeln('There is no telephones with entered manufacturer')
         else
           begin
             writeln;
             printEnterKey();
           end;
readln;
end;
//-------------------------------------------------

// FILTERS DATA BY ENTERED PRICE RANGES
procedure filtByPrice(s: stek);
var range1, range2: real;
    n: integer;
begin
clrscr;
if s = NIL then printNoData()
else
 begin
   getRange(range1, range2);
   n:=0;
   clrscr;

   repeat
     if (s^.price >= range1) and (s^.price <= range2) then
       begin
         if n = 0 then printTableTop();
         printTable(s);
         n:= 1;
       end;
     s:= s^.pointer;
   until s = NIL;


   if n = 0 then writeln('There is no telephones in entered price range')
            else
              begin
                writeln;
                printEnterKey();
              end;
   readln;
   end;
end;
//-------------------------------------------------

// FILTERING OPERTATIONS MENU
procedure filter(s: stek);
var selection, n: integer;
begin

repeat
clrscr;
Writeln('[1] Filter telephones by manufacturer');
Writeln('[2] Filter telephones in selected price range');
Writeln('[3] Go back to menu');

n:=3;
selection:= isSelection(n);

case selection of
1: filtByManfctr(s);
2: filtByPrice(s);
end;
until selection = 3;

end;
//-------------------------------------------------

// COUNTS NUMBER OF RECORDS IN STACK
function elementsNr(s: stek):integer;
begin

elementsNr:=0;
repeat
elementsNr:= elementsNr + 1;
s:= s^.pointer;
until s = NIL

end;
//-------------------------------------------------

// DELETES ONE RECORD FROM STACK
procedure deleteOne(var s: stek);
var nr1,nr2: integer;
    p,k: stek;
begin
clrscr;
if s = NIL then printNoData()
else
 begin
   writeStek(s);
   writeln;
   writeln('Enter number of element which you want to delete');
   nr1:= isselection(elementsNr(s));
   nr2:=1;
   new(p);
   p:=nil;

   repeat
   if nr2 <> nr1 then
        begin
        new(k);
        k^.manfctr:= s^.manfctr;
        k^.model:= s^.model;
        k^.price:= s^.price;
        k^.years:= s^.years;
        k^.threeG:= s^.threeG;
        k^.pointer:= p;
        p:=k;
        s:=s^.pointer;
        end
     else s:=s^.pointer;
   nr2:= nr2 + 1;
   until s = NIL;
   s:= p;
   if nr1 <> 0 then begin
      writeln('Element has been deleted');
      printEnterKey;
      readln;
      end;
   end;
end;
//-------------------------------------------------

// DELETES ALL RECORD FROM STACK
procedure deleteAll(var s: stek);
begin
s:=NIL;
clrscr;
writeln('All elements has been deleted');
printEnterKey();
readln;
end;
//-------------------------------------------------

// DELETE OPERATIONS MENU
procedure delete(var s: stek);
var selection, n: integer;
begin

repeat
clrscr;
Writeln('[1] Delete one entery');
Writeln('[2] Delete all');
Writeln('[3] Go back to menu');

n:=3;
selection:= isSelection(n);

case selection of
1: deleteOne(s);
2: deleteAll(s);
  end;
until selection = 3;

end;
//-------------------------------------------------



// EDITS RECORD WHICH WAS INDICATED
procedure edit(var s: stek);
var nr1,nr2: integer;
    p,k: stek;
begin
clrscr;

if s = NIL then printNoData()
else
 begin
   writeStek(s);
   writeln;
   writeln('Enter number of element which you want to edit');

   nr1:= isselection(elementsNr(s));
   nr2:=1;
   new(p);
   p:=nil;

   repeat
   if nr2 <> nr1 then
        begin
        new(k);
        k^.manfctr:= s^.manfctr;
        k^.model:= s^.model;
        k^.price:= s^.price;
        k^.years:= s^.years;
        k^.threeG:= s^.threeG;
        k^.pointer:= p;
        p:=k;
        s:=s^.pointer;
        end
     else
        begin
        new(k);
        insertData(k);
        k^.pointer:= p;
        p:=k;
        s:=s^.pointer;
        end;
   nr2:= nr2 + 1;
   until s = NIL;

   s:=p;
   if nr1 <> 0 then begin
      writeln('Element has been changed');
      printEnterKey;
      readln;
      end;
   end;
end;
//-------------------------------------------------


var s:stek;
    selection, n: integer;
begin
s:= NIL;

repeat
clrscr;
Writeln('This program is a simple database of telephones.');
Writeln('Operations which you can do with database is written below.');
Writeln;
Writeln('Choose operation:');
Writeln('[1] Load');
Writeln('[2] Write');
Writeln('[3] Save');
Writeln('[4] Insert');
Writeln('[5] Delete');
Writeln('[6] Edit');
Writeln('[7] Statistics Operations');
Writeln('[8] Filter Operations');
Writeln('[9] Advance Filter');
Writeln('[10] Sorting Operations');
Writeln('[11] Exit');

n:=11;
selection:= isSelection(n);

 Case selection of
1: load(s);
2: writef(s);
3: save(s);
4: insert(s);
5: delete(s);
6: edit(s);
7: statistics(s);
8: filter(s);
9: advanceFilter(s);
10: sort(s);
11: halt;
 end;
until selection = 11;
end.
